import java.lang.*;

/*
-------------------------------------------------------------------------------
Estocasticitat demografica
-------------------------------------------------------------------------------
Dades: a (probabilitat de que un "bitxo" tingui *un* descendent, la resta es
       calculen a partir d'aquesta amb la idea que el nombre mig de descendents
       sigui un per "bitxo"), i (nombre inicial de "bitxos"), max (nombre de
       passos de temps que es vol calcular)
Resultats: Fitxer "estoc2.dat". Cada fila es un pas de temps. La primera
           columna es l'ordinal del pas. La segona es el nombre de membres
           de l'especie.
Dades de prova: a=0.9 i=1000 max=3 ==> 0, 1000; 1, 1010; 2, 1013; 3, 1012
Observacions: Per obtenir resultats diferents en execucions diferents cal
              canviar la llavor que es troba a la funcio srand
              El nombre inicial de "bitxos" ha de ser un sencer!
-------------------------------------------------------------------------------
*/

public class Estoc2Calculs {
	double a,traj[];
	int i,max;

	Estoc2Calculs(float a0,int i0,int max0) {
		double b,r,x;
		int j,k,n,m;

		a = (double) a0;
		i = i0;
		max = max0;
		traj = new double[max];

		b = (1.0-a)/2.0;
		traj[0] = i;
		for(n=1;n<max;n++) {
			j = 0;
			for(m=1;m<=i;m++) {
				x = Math.random();
				if(x<a)j = j+1;
				if((x>=a)&&(x<a+b))j = j+2;
			}
			i = j;
			traj[n] = i;
		}
	}
}
